package com.link.base.basic.service;

import com.link.base.basic.dao.mybatis.mapper.PartyRelMapper;
import com.link.core.util.StringUtils;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import javax.annotation.Resource;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Service;

@Service
public class PartyRelServiceImpl implements PartyRelService {
   private static final Map<String, String> orgSecurityMap = new ConcurrentHashMap();
   private static final Map<String, String> postnSecurityMap = new ConcurrentHashMap();
   private static final Map<String, List<String>> orgSecurityList = new ConcurrentHashMap();
   private static final Map<String, List<String>> positionSecurityList = new ConcurrentHashMap();
   @Resource
   private PartyRelMapper partyRelMapper;
   private static final Logger logger = LogManager.getLogger(PartyRelServiceImpl.class);

   public String querySecurityStrByOrgId(String orgId) {
      if (orgSecurityMap.containsKey(orgId)) {
         return (String)orgSecurityMap.get(orgId);
      } else {
         List<String> orgList = this.partyRelMapper.querySecurityStrByOrgId(orgId);
         String targetSecurityStr = null;

         String str;
         for(Iterator var4 = orgList.iterator(); var4.hasNext(); targetSecurityStr = targetSecurityStr.concat("'").concat(str).concat("',")) {
            str = (String)var4.next();
            if (targetSecurityStr == null) {
               targetSecurityStr = "(";
            }
         }

         if (targetSecurityStr == null) {
            orgSecurityMap.put(orgId, (Object)null);
         } else {
            targetSecurityStr = targetSecurityStr.substring(0, targetSecurityStr.length() - 1);
            targetSecurityStr = targetSecurityStr.concat(")");
            orgSecurityMap.put(orgId, targetSecurityStr);
         }

         return targetSecurityStr;
      }
   }

   public String querySecurityStrByPostnId(String postnId) {
      if (postnSecurityMap.containsKey(postnId)) {
         return (String)postnSecurityMap.get(postnId);
      } else {
         List<String> orgList = this.partyRelMapper.querySecurityStrByPostnId(postnId);
         String targetSecurityStr = null;

         String str;
         for(Iterator var4 = orgList.iterator(); var4.hasNext(); targetSecurityStr = targetSecurityStr.concat("'").concat(str).concat("',")) {
            str = (String)var4.next();
            if (targetSecurityStr == null) {
               targetSecurityStr = "(";
            }
         }

         if (targetSecurityStr != null) {
            targetSecurityStr = targetSecurityStr.substring(0, targetSecurityStr.length() - 1);
            targetSecurityStr = targetSecurityStr.concat(")");
            postnSecurityMap.put(postnId, targetSecurityStr);
         }

         return targetSecurityStr;
      }
   }

   public void clearSecurityStrByPostnId() {
      postnSecurityMap.clear();
      positionSecurityList.clear();
   }

   public void clearSecurityStrByOrgId() {
      orgSecurityMap.clear();
      orgSecurityList.clear();
   }

   public List<String> querySecurityListByOrgId(String orgId) {
      if (StringUtils.isBlank(orgId)) {
         return new ArrayList();
      } else if (orgSecurityList.containsKey(orgId)) {
         return (List)orgSecurityList.get(orgId);
      } else {
         List<String> orgList = this.partyRelMapper.querySecurityStrByOrgId(orgId);
         if (orgList == null) {
            orgList = new ArrayList();
         }

         orgSecurityList.put(orgId, orgList);
         return (List)orgList;
      }
   }

   public List<String> querySecurityListByPositionId(String positionId) {
      if (StringUtils.isBlank(positionId)) {
         return new ArrayList();
      } else if (positionSecurityList.containsKey(positionId)) {
         return (List)positionSecurityList.get(positionId);
      } else {
         List<String> positionList = this.partyRelMapper.querySecurityStrByPostnId(positionId);
         if (positionList == null) {
            positionList = new ArrayList();
         }

         positionSecurityList.put(positionId, positionList);
         return (List)positionList;
      }
   }
}
